# ------------------
# Sugar
# QQ: 932180146
# ------------------


module RBC

  # 加载Lib.
  #
  # @param [String] ext_name
  #
  # @return [Boolean]
  #
  # @since 6.3.0
  def self.check_lib7(ext, mv, rv, fv)
    return false if @lib_update
    return false if Sketchup.version.to_i < 15
    unless defined?(RBC::RBC_EXTENSION)
      # require RBC library.
      begin
        require 'RBC_Library_load.rb'
      rescue LoadError => e
        p e
      end
    end
    if defined?(RBC::RBC_VERSION_) && RBC::RBC_VERSION_[0] == mv
      if RBC::RBC_VERSION_[1] >= rv
        update = false
      elsif RBC::RBC_VERSION_[2] >= fv
        update = false
      else
        update = true
      end
    else
      update = true
    end
    # check version.
    if update
      msg = "#{ext.name}: More than #{ext.version} versions of RBC must be installed!(必须安装使用#{mv}.#{rv}.#{fv}版本以上的RBC Library!)"
      Sketchup.status_text = msg
      if Sketchup.version.to_i >= 17
        UI::Notification.new(ext, msg).show
      else
        UI.messagebox(msg)
      end
      @check_lib = true
      false
    end
    !update
  end
end# module RBC

module RBC
  module Extensions
    module CleanupModelTools

      NAME         = "RBC_CleanupModelTools".freeze
      VERSION      = "7.6.2".freeze
      CREATOR      = 'Sugar'.freeze
      PLUGIN_PATH  = __FILE__.force_encoding('UTF-8').freeze
      DIR_NAME     = (NAME+'_v'+VERSION).freeze
      PLUGIN_DIR   = File.join(File.dirname(PLUGIN_PATH), DIR_NAME).freeze

      EXTENSION = SketchupExtension.new(NAME, File.join(PLUGIN_DIR, 'core'))
      EXTENSION.description = "This tool is used to clean up the model."
      EXTENSION.copyright   = "Copyright (c) 2017-#{Time.new.year} Sugar All rights reserved."
      EXTENSION.version     = VERSION
      EXTENSION.creator     = CREATOR
      if RBC.check_lib7(EXTENSION, 7, 6, 0)
        Sketchup.register_extension(EXTENSION, true)
      end

    end # module CleanupModelTools
  end # module Extensions
end # module RBC
